This cheet cheet / general guide will explain what each command will do and when to use it.
It's intended as a general guide/cheet cheet for linux beginners on the command line.

This Cheet Cheet assumes you use a Debian based system like Ubuntu but can be also applied to other Posix systems like MacOS and in some degree to non Posix systems like Windows. There are also definitions for each word that is not well know. 

I would always recommend to watch those 2 Videos to get a core understanding of common Linux things:

https://youtu.be/LKCVKw9CzFo

https://youtu.be/42iQKuQodW4

---
To do:
- [x] Piping via | , >, >>
- [ ] Grep
- [x] ls / ls -la
- [ ] usermod
- [x] cd 
- [ ] man 
- [x] cat
- [ ] --help
- [ ] ssh
- [x] pwd
- [x] rm
- [x] mkdir
- [x] touch
- [x] nano/ vim
- [x] cp
- [x] mv
- [ ] kill
- [ ] htop /top
- [ ] ping
- [ ] scp
- [ ] info
- [ ] history 
- [ ] clear
- [ ] mount
- [ ] ip a
- [ ] permissions
- [ ] external ip address throght things like ip.coolerwuffi.de or curl -4 icanhazip.com
- [ ] curl 
- [ ] Bootloader, like grub or systemd-boot
- [ ] wget
- [ ] Common linux shortcuts
- [x] apt
- [x] systemctl/systemd
- [x] sudo

---

# Definitions
#### Distro/ Distribution
A so called "Distro" short for Distribution could be intepreded as a sort of flavor/Versions of Linux. Popular Server Linux Distros are Debain, Ubuntu, RHEL (Redhat Enterprise Linux) and Alpine Linux

#### Repo/ Repository
Repository short "repo" is in general a place to store data, most common are git repositorys for code or package repositorys for Software

#### What is a .deb/.rpm?
Deb and Rpm files are softwarebundels that are used to install Software on their respective platforms. Debain based Distros use .deb files to install software while RHEL or SUSE based Distros use the .rpm format

#### Everything has an alternative
What you need to remember on Linux systems is that almost everything has an alternative way/software to do the same or similar jobs. This fragmentation has some standards and common software. Ex. The most common package manager to install software on Linux ist apt but there are also may alternatives out there like dnf, pacman, apk and so on. The most importened thing is to remember the core concepts. On the most common Distros most things are the same, GNU userspace, Systemd as a initsystem and so on

#### What is a Linux daemon?
**A process which runs in the background and is not interactive**. They have no controlling terminal on their own from the user's perspective from the desktop. They continue to exist and operate regardless of any user being logged into the server if the computer is on( [See](https://help.interfaceware.com/v6/differences-between-processes-daemons-and-services)). On most Linux system you will use Systemd for that.
'* On Windows there are Windows Services similar to Linux daemons

#### Use TAB were possible
The Tab key is mostly forgotten today but on the command line it is essential for easy fast navigation use it every were possible

---
# Common Linux Tools explained
### Sudo
Sudo is a program to execute a command as another user in most cases the root user. The root user is the admin of every Linux out there. So if we want to run a command with elevated privages we will use `sudo`. Common command that require given privalages are:
* `systemctl enable/disable/start/stop`
* `apt install/remove/update/upgrade`
### Apt 
Apt is a so called package manager. Those are used to install Software or Libarys form Package repo. Those are hosted by your Linux Distro maintainers  but you can also install third party software via .deb files. Apt has many arguements the most common are `search`, `install`, `update`, `upgrade`, `remove`, `list` and `show`. 
Here is a list which does what:
* `search` searches throught the package index for the given string
	* `apt search firefox` this would give you results of packages that have either firefox in their name or description
* `install` installs the software that is in the repo or local
	* `apt install firefox` will install firefox from the repository
	*  `apt install ./firefox.deb` This will install the local firefox file onto your system
* `update` will update your repository index.
	* So that if there is a new version of a software on the repo your host knows what is the newest version of given software
	* use `apt update`
* `upgrade` Updates your installed software *including your system software*
	* This will upgrade all the installed software to the newest version of given software, it's recommended to restart your host after an upgrade
	* use `apt upgrade`
* `remove` will remove/uninstalls software from your system
	* very easy to use
	* `apt remove <installed_software_here>`
*  `list` list out the available software on your repo
	* mostly used in combination with grep and the `--installed` option to list the local installed packages
	* `apt list --installed |grep firefox`  This would list out the installed packages and uses grep to search for packages that have "firefox" in their name
* `show` shows you information about the package
	* shows information about the package, things like dependencys upsteams Webpage, maintainer, version and so on
	* `apt show firefox`

### Systemd/Systemctl
Systemd is that so called init system that runs daemons or sockets on a given system while systemctl is the software interface to control Systemd.
Systemd is for the user a way to run software consitenly in the background on a given host. Common things that run like that are web, printing and virtualization. 
The most importend systemctl commands are `status`, `enable`, `disable`, `start`, `stop`, `restart` and `reload`. With those you can contol the systemdaemons.
**status**: Displays the status of a service
	+ Example: `systemctl status docker`.
* **enable**: Enables a service so that it is automatically started at system startup
	+ Example: `systemctl enable docker`
* **disable**: Disables a service so that it is no longer started automatically at system startup
	+ Example: `systemctl disable docker`
* **start**: Starts a service
	+ Example: `systemctl start docker`
* **stop**: Stops a service
	+ Example: `systemctl stop docker`
* **restart**: Restarts a service
	+ Example: `systemctl restart docker`
* **reload**: Reloads the configuration of a service
	+ Example: `systemctl reload docker`.

### File navigation & management 
Under Linux and other other Unix like and other Systems you will use nearly the same commands to navigate your file tree and manage them. The most well known Unix like desktopsystems are Linux, Android, MacOS and FreeBSD many command. They are mostly follow the Posix Standard.

#### Core Concepts
So to understand the most common things, I will explain them now rather than later. In Linux you don't have a C: or D: drive like in Windows instead you have the `/` aka root directory. For more information about multiple drives see [mount](#mount) This directory holds all files and folders of your system. The most imported root directorys are:
* `/etc` short for Editable Text Configuration
* `/home` where the non root user files are located
* `/dev` contains external devices like hard drives and other things
	* `/dev/urandom` contains a unlimited number of random data
	* `/dev/null` all data moved to or from there is empty
	* for more read see the [dd](#dd) section
* `/root` is the home directory of the root user
* `/tmp` is a temporarily directory that will clean itself after each reboot
* `/usr` contains system wide non essential software and librarys
* `/sbin` contains system essential software
* `/bin` contains your software binarys

But there are also some relative path variables that you need to remember:
* `~/` This wave character is representative for the home dir of the current user
	* in case of the root user `/root/`
* `./` A single dot indicates the current working directory
* `../` Two dots represent the parent directory of the current working directory
* `.ssh/` a dot before a directory indicates to the system that it is a hidden directory
* if you don't specify a directory path but insted only `Documents/test.txt` your system will try to use a relative directory with that name: `./Documents/test.txt`
	* This is really handy for fast navigation on the command line
* you can use the `*` as a symbol to specify that every things is meant
	* if you want so select all files or directorys that start or end with `start` use `*start` or `start*`

#### Commands to Navigate your file tree
##### ls
* `ls` short for list is the most common command to list existing files and directorys that are inside of a given directory
	* `ls -a` will show you all directorys/files including hidden ones
	* `ls -l` will show the contend in a list format
	*  `ls` arguments can be combined
		* like `ls -la` to show all contents of a file in a list format
	* in Windows you would use traditionally the `dir` command for that

##### pwd
* `pwd` will print out the current working directory

##### cd
* `cd` to "change the directory" 
	* if you run `cd` without a directory it will go to the home dir of your user like `cd ~/`
	* can be used with relative paths (usually way faster)
		* like`cd ./.ssh` or `cd ~/.ssh` instead of ` cd /home/testuser/.ssh`
	* `cd !!` to go back to the previous directory

#### Modifying content
##### touch
`touch`will create a empty file
* `touch example.txt`
##### mkdir
`mkdir` will create a empty directory
* `mkdir ~/` 

##### Edit files using an text editor of choice ex. [nano](#nano) or [vim](#vi-vim-vim)
##### rm
`rm` to remove files or/and directorys
* use `rm -r` to remove directorys
* **be EXTEMLY CAREFULL with `rm` it removes ALL FILES and they GONE no trash dir just gone**
* **never ever run `rm -rf /`** it will stop your system form working and removes all other files
* used like: `rm testfile.txt` or `rm -r ./testdir`
##### cat
 `cat` will print out the contend of a given file
 * used like : `cat testfile.txt`

### Piping, Redirecting and Shellscripting
On the most Linux systems the default shell ist "bash" on some other it is "zsh". On MacOS is "zsh" the default shell. The post imported thing is that they are Poisx complaint.

##### Piping
On the command line you can chain commands together like following example:
```bash
cat testfile.txt |grep test
```
In this example we are using [cat](#cat) to print out the contend of the testfile. That contend is piped via the pipe symbol `|` to [grep](#grep). Grep will search for a given string in our case test. So if a line in the testfile.txt has the string test in it grep will print out the lines with the given string in it

##### Redirecting
There is also another symbol used on the command line with the "output redirection operator" `>` you can redirect the output to a file
```bash
apt list --installed > installedpackages.txt
```
Here we are listing the installed packages via [apt](#apt) and then redirecting the output to the "installedpackages.txt"

If we would repeat that command it will overwrite the existing file but if we want to append it to the file we can use the redirection symbol twiste `>>` 
```bash
echo "hi, this is a test" >> installedpackages.txt
```

##### Scripting 
If your want to combined commands you can write a shell script for that. You can use a graphical text editor like vscode or you could use a terminal text editor like [nano](#nano) or [vim](#vi-vim-vim)
```bash
#!/bin/bash

apt list --installed > installedpackages.txt

# This  will check via grepp if Firefox is in the installedpackages list
if ! grep -q "firefox" installedpackages.txt; then
    echo "Firefox is not installed. Installing..."
    sudo apt install -y firefox 
else
    echo "Firefox is already installed :D"
fi
```

### Nano
Nano is a simple editor nice for quick edits but hides a lot of it's features behind config files. 
To use nano run `nano testfile.txt` if the file already exists it will load up the file. If not nano will create a new file
If you fished your edit press `ctrl + o` to save the file and then press `ctrl + x` to exit nano

### Vi/Vim/Nvim
Vi, Vim and Nvim are all text editors that build upon another. I would always recommend to use at least vim, because of it's text highlighting. The biggest upgrade to Nvim in my opinion is the build in file explorer which is really handy. They are not really easy for beginners cause the mode editor model isn't the norm nowadays and you have to remember some shortcuts. The most important is `Esc` to go back into Normal mode, then press `:` and then `q!`. This will force quit vim without saving.

Those are all mode based editors. You have 3 distinct modes, Normal, Insert and Visual. 
* You can enter Normal mode via the `Esc` key it's the default mode
* To enter Insert mode press the `I` key, know you can write/edit your files
  * press `Esc` to return to normal mode
* To enter Visual mode press the `V` key, know you can mark your text and copy it to your clipboard with `Y`, with `P` you can past your clipboard content into the editor
   * press `Esc` to return to normal mode
If your are done with your edit go back to normal mode, then press `:` and then `wq` to save and quit

some useful shortcuts: 
* Normal mode: press `U` to go back to the change before
* Normal mode: press `cont + R ` to go forward to the newest change
* Normal mode: press `/` then type in a string to search for given string thought the file
* Nvim only Normal mode: press `:` and then `E` and `Enter` and the builtin file explorer opens it's self
  


  
### ps/top/htop
WIP (Work in Progress)

### dd
WIP

### Neofetch/fastfetch
Neofetch and Fastfetch are tools to get information about your host system, which can be very import. They are both compatible with the same config but fastfetch is faster and still maintained. But it's not in every repo yet so Neofetch is there the way to go

```bash
jp:~/ $ neofetch
        ,'''''.      
       |   ,.  |    D E V E L C O O K I N G 
       |  |  '_'    _____________________ 
  ,....|  |..       OS: Fedora Linux 40 (GNOME Edition) 
.'  ,_;|   ..'      Kernel: 6.11.1-200.fsync.fc40.x86_64 
|  |   |  |         Uptime: 4 hours, 51 mins 
|  ',_,'  |         Packages: 3007 (dnf) 
   '''''            DE: GNOME 46.5 (wayland) 
                    Terminal: gnome-terminal 
                    CPU: AMD Ryzen 7 5800X (16) @ 4.851GHz [44.1°on] 
                    GPU: AMD ATI RX 5700 XT RAW II 
                    Memory: 6139.79 MiB / 31980.52 MiB 
                    Song: Unknown Artist - Unknown Album - Unknown Song 
                    ▂▂ ▂▂ ▂▂ ▂▂ ▂▂ ▂▂ ▂▂ 
                    _____________________ 


```

### Grep
Grep is a basic but very blessing tool on linux with it you can search throught really anything (which is text based). Its most common used in combination with [Piping, Redirecting and Shellscripting](#Piping,-Redirecting-and-Shellscripting).

It can be used with "basic Syntax like:
```
apt list --installed |grep vpn
```
This would show you all installed packages with the "vpn" in the name.

with the `-E` flag standing for Extended Regular Expressions grep can search for a ERE for a definition see [here](https://en.wikibooks.org/wiki/Regular_Expressions/POSIX-Extended_Regular_Expressions)
```
grep '^linux' file.txt
```

for more examples [see](https://linuxize.com/post/regular-expressions-in-grep/)


### ssh
SSH is a remote tool to connect and administrate a bunch of systems. You can compare it to products like Teamviewer or Microsofts Remote deskop app. We will go over the base model of ssh first.

This articel from [digial ocean](https://www.digitalocean.com/community/tutorials/how-to-configure-ssh-key-based-authentication-on-a-linux-server) is a great learning ground

##### ssh client server model
So to connect to a ssh server you will need a ssh server and a ssh client. A popular ssh server is the OpenSSH-Server or the Windows-SSH Server. Popular clients are the OpenSSH-Clients available on every OS. Another popular SSH client is Putty on windows.

##### SSH server config
SSH is a daemon service which can be controled via systemctl. You could restart ssh for ex. with

```
systemctl restart ssh
```

We will here only mension Linux's OpenSSH server. On a default server you will have a ssh server preinstalled. In `/etc/ssh/sshd_config` you can configure globle settings for your ssh server like the port which the server will be accessible in the future. Another big talking point is root access on a server. A direct root access should be disabled accept you are only using a ssh keypair. A keypair is like a key and a doorlock. Only a key can open the door. If you use ssh-keygen you will have a private and public key. A private key should be allways keept private. Nobody else exapt you should have access to your private ssh key. The public key is to be placed on your server we will later get to this. 

##### Setup ssh on the client and server for a safe connection
Please make sure to have genereate a ssh keypair via [ssh-keygen](https://www.ssh.com/academy/ssh/keygen), it works on win terminal, linux and MacOS. 
If you done that you will have two new files in you `$HOME/.ssh/` directory. Here we can use cat to cat out the `.pub` key. You can copy it to your clipboard. 


If you are connected to a ssh server you will go into the Home directory of the user you want to connect as. In case of the root user `/root` otherwise `/home/$USERNAME`. You have to create now probaly a dir called .ssh `mkdir .ssh`. In there we now create a file called "authorized_keys". We will now edit it via our text editor of choice. You will now paste you public key into there. It should be oneliner. If it all worked, you can test the connection via
```
ssh <EDIT_USERNAME>@<IP_ADDRESS_OF_YOUR SERVER>
```
. If you dont know the ip address of you server you can use `ip a ` to show that to you.


### scp
WIP

### ping
WIP

### mount
WIP


### Nice to know software
* lynx/links
* browsh
* wireguard
* nmap
* rsync
* gnu shreed
* Networkmanager/ systemd-network /  Netplan
* nm-tui
---
# In Action
In Case you want to install software for ex. Firefox
```bash
sudo apt install firefox
```

If you use this command you will elevate your privileges with [sudo](#sudo) to the root (admin) user and execute [apt](#apt) with those privileges to install firefox on your system

---

```bash
systemctl enable --now docker
```
With this command you would enable docker as a [Systemdaemon](# What is a linux daemon) persistently and now on the running system, so you don't have to enable docker and start it now manually.